Loading...
Searching...
No Matches
or/ungtr: Generate Q from tridiagonal reduction
Dense LA » Eigenvalues » Symmetric/Hermitian eigenvalues

## Functions

magma_int_t | magma_cungtr (magma_uplo_t uplo, magma_int_t n, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *work, magma_int_t lwork, magmaFloatComplex *dT, magma_int_t nb, magma_int_t *info)
| CUNGTR generates a complex unitary matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by CHETRD:
magma_int_t | magma_dorgtr (magma_uplo_t uplo, magma_int_t n, double *A, magma_int_t lda, double *tau, double *work, magma_int_t lwork, double *dT, magma_int_t nb, magma_int_t *info)
| DORGTR generates a real orthogonal matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by DSYTRD:
magma_int_t | magma_sorgtr (magma_uplo_t uplo, magma_int_t n, float *A, magma_int_t lda, float *tau, float *work, magma_int_t lwork, float *dT, magma_int_t nb, magma_int_t *info)
| SORGTR generates a real orthogonal matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by SSYTRD:
magma_int_t | magma_zungtr (magma_uplo_t uplo, magma_int_t n, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *work, magma_int_t lwork, magmaDoubleComplex *dT, magma_int_t nb, magma_int_t *info)
| ZUNGTR generates a complex unitary matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by ZHETRD:

## Detailed Description

## Function Documentation

## magma_cungtr()

magma_int_t magma_cungtr | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magmaFloatComplex * | dT,
|  | magma_int_t | nb,
|  | magma_int_t * | info )

CUNGTR generates a complex unitary matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by CHETRD:

if UPLO = MagmaUpper, Q = H(n-1) . . . H(2) H(1),

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(n-1).

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from CHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from CHETRD.

  [in] | n | INTEGER The order of the matrix Q. N >= 0.
  [in,out] | A | COMPLEX array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by CHETRD. On exit, the N-by-N unitary matrix Q.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= N.
  [in] | tau | COMPLEX array, dimension (N-1) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CHETRD.
  [out] | work | (workspace) COMPLEX array, dimension (LWORK) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= N-1. For optimum performance LWORK >= N*NB, where NB is the optimal blocksize. If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.
  [in] | dT | COMPLEX array on the GPU device. DT contains the T matrices used in blocking the elementary reflectors H(i) as returned by magma_chetrd.
  [in] | nb | INTEGER This is the block size used in CHETRD, and correspondingly the size of the T matrices, used in the factorization, and stored in DT.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dorgtr()

magma_int_t magma_dorgtr | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | work,
|  | magma_int_t | lwork,
|  | double * | dT,
|  | magma_int_t | nb,
|  | magma_int_t * | info )

DORGTR generates a real orthogonal matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by DSYTRD:

if UPLO = MagmaUpper, Q = H(n-1) . . . H(2) H(1),

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(n-1).

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from DSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from DSYTRD.

  [in] | n | INTEGER The order of the matrix Q. N >= 0.
  [in,out] | A | DOUBLE PRECISION array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by DSYTRD. On exit, the N-by-N orthogonal matrix Q.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= N.
  [in] | tau | DOUBLE PRECISION array, dimension (N-1) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DSYTRD.
  [out] | work | (workspace) DOUBLE PRECISION array, dimension (LWORK) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= N-1. For optimum performance LWORK >= N*NB, where NB is the optimal blocksize. If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.
  [in] | dT | DOUBLE PRECISION array on the GPU device. DT contains the T matrices used in blocking the elementary reflectors H(i) as returned by magma_dsytrd.
  [in] | nb | INTEGER This is the block size used in DSYTRD, and correspondingly the size of the T matrices, used in the factorization, and stored in DT.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sorgtr()

magma_int_t magma_sorgtr | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | work,
|  | magma_int_t | lwork,
|  | float * | dT,
|  | magma_int_t | nb,
|  | magma_int_t * | info )

SORGTR generates a real orthogonal matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by SSYTRD:

if UPLO = MagmaUpper, Q = H(n-1) . . . H(2) H(1),

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(n-1).

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from SSYTRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from SSYTRD.

  [in] | n | INTEGER The order of the matrix Q. N >= 0.
  [in,out] | A | REAL array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by SSYTRD. On exit, the N-by-N orthogonal matrix Q.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= N.
  [in] | tau | REAL array, dimension (N-1) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SSYTRD.
  [out] | work | (workspace) REAL array, dimension (LWORK) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= N-1. For optimum performance LWORK >= N*NB, where NB is the optimal blocksize. If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.
  [in] | dT | REAL array on the GPU device. DT contains the T matrices used in blocking the elementary reflectors H(i) as returned by magma_ssytrd.
  [in] | nb | INTEGER This is the block size used in SSYTRD, and correspondingly the size of the T matrices, used in the factorization, and stored in DT.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zungtr()

magma_int_t magma_zungtr | ( | magma_uplo_t | uplo,
|  | magma_int_t | n,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magmaDoubleComplex * | dT,
|  | magma_int_t | nb,
|  | magma_int_t * | info )

ZUNGTR generates a complex unitary matrix Q which is defined as the product of n-1 elementary reflectors of order N, as returned by ZHETRD:

if UPLO = MagmaUpper, Q = H(n-1) . . . H(2) H(1),

if UPLO = MagmaLower, Q = H(1) H(2) . . . H(n-1).

Parameters

  [in]

  uplo

  magma_uplo_t
  - = MagmaUpper: Upper triangle of A contains elementary reflectors from ZHETRD;
  - = MagmaLower: Lower triangle of A contains elementary reflectors from ZHETRD.

  [in] | n | INTEGER The order of the matrix Q. N >= 0.
  [in,out] | A | COMPLEX_16 array, dimension (LDA,N) On entry, the vectors which define the elementary reflectors, as returned by ZHETRD. On exit, the N-by-N unitary matrix Q.
  [in] | lda | INTEGER The leading dimension of the array A. LDA >= N.
  [in] | tau | COMPLEX_16 array, dimension (N-1) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZHETRD.
  [out] | work | (workspace) COMPLEX_16 array, dimension (LWORK) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.
  [in] | lwork | INTEGER The dimension of the array WORK. LWORK >= N-1. For optimum performance LWORK >= N*NB, where NB is the optimal blocksize. If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.
  [in] | dT | COMPLEX_16 array on the GPU device. DT contains the T matrices used in blocking the elementary reflectors H(i) as returned by magma_zhetrd.
  [in] | nb | INTEGER This is the block size used in ZHETRD, and correspondingly the size of the T matrices, used in the factorization, and stored in DT.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value